unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    MemoPIDs: TMemo;
    GroupBox2: TGroupBox;
    SpinEdit1: TSpinEdit;
    BitBtn1: TBitBtn;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MAS_PID_PROCESS:array of integer; //    
  i:integer;
implementation

{$R *.dfm}

/////       ...      
function ForceForegroundWindow(hWnd: HWND): BOOL;
const
  SPI_GETFOREGROUNDLOCKTIMEOUT = $2000;
  SPI_SETFOREGROUNDLOCKTIMEOUT = $2001;
var
  OsVerInfo: TOSVersionInfo;
  Win32MajorVersion: Integer;
  Win32MinorVersion: Integer;
  Win32Platform: Integer;
  ForegroundThreadID: DWORD;
  ThisThreadID: DWORD;
  Timeout: DWORD;
begin
  OsVerInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  GetVersionEx(osVerInfo);
  Win32MajorVersion := OsVerInfo.dwMajorVersion;
  Win32MinorVersion := OsVerInfo.dwMinorVersion;
  Win32Platform := OsVerInfo.dwPlatformId;
  if IsIconic(hWnd) then ShowWindow(hWnd, SW_RESTORE);
  if GetForegroundWindow = hWnd then Result := True
  else
  begin
    if ((Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion > 4)) or
       ((Win32Platform = VER_PLATFORM_WIN32_WINDOWS) and ((Win32MajorVersion > 4) or
       ((Win32MajorVersion = 4) and (Win32MinorVersion > 0)))) then
    begin
      Result := False;
      ForegroundThreadID := GetWindowThreadProcessID(GetForegroundWindow, nil);
      ThisThreadID := GetWindowThreadPRocessId(hWnd, nil);
      if AttachThreadInput(ThisThreadID, ForegroundThreadID, True) then
      begin
        BringWindowToTop(hWnd);
        SetForegroundWindow(hWnd);
        AttachThreadInput(ThisThreadID, ForegroundThreadID, False);
        Result := (GetForegroundWindow = hWnd);
      end;
      if not Result then
      begin
        SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @Timeout, 0);
        SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, nil, SPIF_SENDCHANGE);
        BringWindowToTop(hWnd);
        SetForegroundWindow(hWnd);
        SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, @Timeout, SPIF_SENDCHANGE);
      end;
    end
    else
    begin
      BringWindowToTop(hWnd);
      SetForegroundWindow(hWnd);
    end;
    Result := (GetForegroundWindow = hWnd);
  end;
end;


//   PID   ,      
function FindFunc(h:hwnd; lparam:LPARAM):boolean;stdcall;
var
  dwPID:DWORD;
begin
result:=true;
GetWindowThreadProcessId(h,@dwPID);
if dwPID=DWORD(lparam) then
  begin                 //    PID ,       
  if IsIconic(h) then ShowWindow(h, SW_SHOWNORMAL);   //    

  //SetForegroundWindow(h);  //      
  ForceForegroundWindow(h) ;//      ,     
  end;
end;



procedure TForm1.BitBtn1Click(Sender: TObject);
begin
MAS_PID_PROCESS:=nil;
SetLength(MAS_PID_PROCESS,MemoPIDs.Lines.Count);
Timer1.Interval:= SpinEdit1.Value*1000;

for i:=0 to MemoPIDs.Lines.Count -1 do   //  
  begin
  MAS_PID_PROCESS[i]:=STRTOINT(MemoPIDs.Lines[i]);
  end;

  i:=0;

  if Timer1.Enabled = false then
    begin
    Timer1.Enabled:=true ;
    Form1.Caption:='Rotation windows ... start';
    end
    else
      begin
      Form1.Caption:='Rotation windows ... stop';
      Timer1.Enabled:=false;
      end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if i> length( MAS_PID_PROCESS)-1 then i:=0;
//if i = 0 then inc(i);
EnumWindows(@FindFunc,MAS_PID_PROCESS[i]); //        //       
inc(i);
end;

end.


3076
2488